//
//  KSErrorMessages.h
//  KonySyncV2
//
//  Created by Vishnu Satis on 01/11/17.
//  Copyright © 2017 Kony. All rights reserved.
//

#import <Foundation/Foundation.h>


//-----------------------------------
// Error messages for Network Errors
//-----------------------------------
FOUNDATION_EXPORT NSString *const EM_NW_GENERIC_NETWORK_ERROR;
FOUNDATION_EXPORT NSString *const EM_NW_CONNECTION_TIMEOUT;
FOUNDATION_EXPORT NSString *const EM_NW_SOCKET_TIMEOUT;
FOUNDATION_EXPORT NSString *const EM_NW_SECURITY_ERROR;
FOUNDATION_EXPORT NSString *const EM_NW_CANNOT_CONNECT_TO_HOST;
FOUNDATION_EXPORT NSString *const EM_NW_CANNOT_RESOLVE_HOST;
FOUNDATION_EXPORT NSString *const EM_NW_INTERNET_CONNECTIVITY_NOT_AVAILABLE;
FOUNDATION_EXPORT NSString *const EM_NW_INVALID_RESPONSE_OBJECT;
FOUNDATION_EXPORT NSString *const EM_NW_INVALID_OPSTATUS_FROM_SERVER;
FOUNDATION_EXPORT NSString *const EM_NW_INVALID_URL;
FOUNDATION_EXPORT NSString *const EM_NW_MESSAGE_INTEGRITY_FAILURE;
FOUNDATION_EXPORT NSString *const EM_NW_REQUEST_ALREADY_IN_PROGRESS;

//-------------------------------
//Error messages for CRUD Errors
//-------------------------------
FOUNDATION_EXPORT NSString *const EM_CRUD_GENERIC_ERROR;
FOUNDATION_EXPORT NSString *const EM_CRUD_RECORD_NOT_IN_MAIN_TABLE;
FOUNDATION_EXPORT NSString *const EM_CRUD_REFERENTIAL_INTEGRITY_VIOLATION;
FOUNDATION_EXPORT NSString *const EM_CRUD_PRIMARY_KEYS_UPDATE_NOT_ALLOWED;
FOUNDATION_EXPORT NSString *const EM_CRUD_INVALID_OPTIONS;
FOUNDATION_EXPORT NSString *const EM_CRUD_NULL_OR_EMPTY_PRIMARY_KEY_VALUE;
FOUNDATION_EXPORT NSString *const EM_CRUD_NULL_OR_EMPTY_COLUMN_NAME_IN_ORDERBY_MAP;
FOUNDATION_EXPORT NSString *const EM_CRUD_NULL_SDKRECORD;
FOUNDATION_EXPORT NSString *const EM_CRUD_MANDATORY_COLUMNS_MISSING;
FOUNDATION_EXPORT NSString *const EM_CRUD_VALUE_SENT_FOR_AUTOGENERATED_COLUMN;
FOUNDATION_EXPORT NSString *const EM_CRUD_INVALID_ATTRIBUTE;
FOUNDATION_EXPORT NSString *const EM_CRUD_DATATYPE_OR_LENGTH_MISMATCH;
FOUNDATION_EXPORT NSString *const EM_CRUD_NULL_OR_EMPTY_OPTIONS;
FOUNDATION_EXPORT NSString *const EM_CRUD_MUTUALLY_EXCLUSIVE_OPTIONS_USED;
FOUNDATION_EXPORT NSString *const EM_CRUD_INVALID_GET_SQL_QUERY;
FOUNDATION_EXPORT NSString *const EM_CRUD_RECORD_NOT_IN_MAIN_OR_ORIGINAL_TABLE;

//--------------------------------
//Error messages for Setup Errors
//--------------------------------
FOUNDATION_EXPORT NSString *const EM_SETUP_GENERIC_ERROR;
FOUNDATION_EXPORT NSString *const EM_SETUP_DB_SCHEMA_SETUP_ERROR;
FOUNDATION_EXPORT NSString *const EM_SETUP_METADATA_REFRESH_ERROR;
FOUNDATION_EXPORT NSString *const EM_SETUP_OBJECT_METADATA_NOT_FOUND;
FOUNDATION_EXPORT NSString *const EM_SETUP_NAMESPACE_METADATA_NOT_FOUND;
FOUNDATION_EXPORT NSString *const EM_SETUP_ROOT_METADATA_NOT_FOUND;
FOUNDATION_EXPORT NSString *const EM_SETUP_OBJECT_ATTRIBUTE_METADATA_PARSE_ERROR;
FOUNDATION_EXPORT NSString *const EM_SETUP_UNABLE_TO_PARSE_METADATA_JSON_OBJECT_METADATA;
FOUNDATION_EXPORT NSString *const EM_SETUP_UNABLE_TO_PARSE_METADATA_JSON_RELATIONSHIP;
FOUNDATION_EXPORT NSString *const EM_SETUP_UNABLE_TO_PARSE_METADATA_JSON;
FOUNDATION_EXPORT NSString *const EM_SETUP_INVALID_ROOT_METADATA_OBJECT;
FOUNDATION_EXPORT NSString *const EM_SETUP_EMPTY_METADATA_DELTA_CONTEXT;
FOUNDATION_EXPORT NSString *const EM_INVALID_METADATA_JSON;
FOUNDATION_EXPORT NSString *const EM_SETUP_TABLE_CREATION_ERROR;
FOUNDATION_EXPORT NSString *const EM_SETUP_METADATA_NAMESPACES_NIL;
FOUNDATION_EXPORT NSString *const EM_SETUP_METADATA_OBJECTS_NIL;
FOUNDATION_EXPORT NSString *const EM_SETUP_INVALID_RELATIONSHIP_TYPE;
FOUNDATION_EXPORT NSString *const EM_SETUP_INVALID_METADATA_URL;
FOUNDATION_EXPORT NSString *const EM_SETUP_CANNOT_GENERATE_INITIAL_INDICES;
FOUNDATION_EXPORT NSString *const EM_SETUP_METADATA_ATTRIBUTES_NIL;
FOUNDATION_EXPORT NSString *const EM_SETUP_ATTRIBUTE_OPERATIONS_EMPTY_OR_NULL;
FOUNDATION_EXPORT NSString *const EM_SETUP_UNABLE_TO_SERIALIZE_DELTA_CONTEXT_VALUE;
FOUNDATION_EXPORT NSString *const EM_SETUP_UNABLE_TO_SERIALIZE;
FOUNDATION_EXPORT NSString *const EM_SETUP_INPROGRESS;
FOUNDATION_EXPORT NSString *const EM_SYNC_SETUP_CANCEL_SDKOBJECT_NULL;
FOUNDATION_EXPORT NSString *const EM_SYNC_NO_SUCH_SYNCING_TASK_FOR_CANCELLATION;
FOUNDATION_EXPORT NSString *const EM_SYNC_CANCELLED;
FOUNDATION_EXPORT NSString *const EM_SYNC_CANCEL_FAILURE;

//------------------------------------------------
// Error messages for Metadata Errors
//------------------------------------------------
FOUNDATION_EXPORT NSString *const EM_METADATA_SDKOBJECT_SYNC_NAME_NIL_OR_EMPTY;
FOUNDATION_EXPORT NSString *const EM_METADATA_SDKOBJECTSERVICE_SYNC_NAME_NIL_OR_EMPTY;
FOUNDATION_EXPORT NSString *const EM_METADATA_UNABLE_TO_PARSE_METADATA_JSON_NAMESPACE_METADATA;
FOUNDATION_EXPORT NSString *const EM_METADATA_OBJECT_NAME_EMPTY;
FOUNDATION_EXPORT NSString *const EM_METADATA_DOWNLOAD_CONTEXT_EMPTY_FOR_OBJECT;
FOUNDATION_EXPORT NSString *const EM_SETUP_INVALID_OBJECT_SERVICE_NAME;
FOUNDATION_EXPORT NSString *const EM_METADATA_METAINFO_TABLE_DOES_NOT_EXIST;
FOUNDATION_EXPORT NSString *const EM_METADATA_METAINFO_TABLE_INSERT_RECORD_FAILED;
FOUNDATION_EXPORT NSString *const EM_METADATA_ATTRIBUTE_NAME_NULL_OR_EMPTY;
FOUNDATION_EXPORT NSString *const EM_METADATA_METAINFO_CRUD_ERROR;
FOUNDATION_EXPORT NSString *const EM_METADATA_META_INFO_NULL_FOR_OBJECT_SERVICE;
FOUNDATION_EXPORT NSString *const EM_IS_CACHE_ENABLED_FLAG_NOT_FOUND;

//--------------------------------
// Error messages for Drop Errors
//--------------------------------
FOUNDATION_EXPORT NSString *const EM_DROP_DB_FAILED;

//---------------------------------
//Error messages for Sync Errors
//---------------------------------
FOUNDATION_EXPORT NSString *const EM_SYNC_GENERIC_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_INPROGRESS;
FOUNDATION_EXPORT NSString *const EM_SYNC_OBJECTSERVICE_ENDPOINT_URL_IS_NULL;
FOUNDATION_EXPORT NSString *const EM_SYNC_OBJECT_ENDPOINT_URL_IS_NULL;
FOUNDATION_EXPORT NSString *const EM_SYNC_OBJECT_ENDPOINT_VERSION_IS_NULL;
FOUNDATION_EXPORT NSString *const EM_SYNC_INVALID_OBJECT_RECORD_ACTION;
FOUNDATION_EXPORT NSString *const EM_SYNC_NO_RELATIONSHIP_FOUND_BETWEEN_OBJECTS;
FOUNDATION_EXPORT NSString *const EM_SYNC_SOURCE_AND_TARGET_COUNT_FOR_RELATED_OBJECTS_NOT_SAME;
FOUNDATION_EXPORT NSString *const EM_SYNC_MORE_THAN_ONE_PARENT_FOUND_FOR_A_CHILD_RECORD;
FOUNDATION_EXPORT NSString *const EM_SYNC_HIERARCHICAL_UPLOAD_BUILDER_MAX_PASS_COUNT_REACHED;
FOUNDATION_EXPORT NSString *const EM_SYNC_GENERIC_JSON_PARSING_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_GENERIC_ROLLBACK_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_INVALID_FILTERS;
FOUNDATION_EXPORT NSString *const EM_SYNC_UPLOAD_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_DOWNLOAD_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_CACHE_UPLOAD_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_INVALID_SYNC_TYPE;
FOUNDATION_EXPORT NSString *const EM_SYNC_OBJECTSERVICE_CLEAR_DATA_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_OBJECT_CLEAR_DATA;
FOUNDATION_EXPORT NSString *const EM_APPLICATION_SYNC_INVALID_OPTIONS;
FOUNDATION_EXPORT NSString *const EM_APPLICATION_SYNC_NO_OBJECTSERVICES_FOUND;
FOUNDATION_EXPORT NSString *const EM_SYNC_PENDING_RECORDS_ERROR;
FOUNDATION_EXPORT NSString *const EM_SYNC_EMPTY_PRIMARYKEY_VALUE;

//---------------------------------
//Error Messages for Binary Errors
//---------------------------------
FOUNDATION_EXPORT NSString *const EM_BINARY_GENERIC_ERROR;
FOUNDATION_EXPORT NSString *const EM_BINARY_NOT_A_BINARY_COLUMN;
FOUNDATION_EXPORT NSString *const EM_BINARY_INVALID_CHUNK_SIZE;
FOUNDATION_EXPORT NSString *const EM_BINARY_FILE_PATH_PERSISTENCE_FAILED;
FOUNDATION_EXPORT NSString *const EM_BINARY_DOWNLOAD_FAILED;
FOUNDATION_EXPORT NSString *const EM_BINARY_INVALID_STATUS_QUERY_TYPE;
FOUNDATION_EXPORT NSString *const EM_BINARY_STATUS_INVALID_OPTIONS;

//-----------------------------------
//Error messages for Internal Errors
//-----------------------------------

FOUNDATION_EXPORT NSString *const EM_INTERNAL_GENERIC_QUERY_BUILDER_ERROR_CODE;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_INVALID_ACTION_TYPE_SENT_TO_ORMFACTORY;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_METADATA_REFRESH_STATUS_NIL;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_INVALID_SYNC_MODE;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_INVALID_VALUE_OF_PARAMETERS;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_COULD_NOT_INITIALIZE_METADATA_TABLE_UTILS_OBJECT;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_DELEGATOR_ERROR;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_OBJECT_METADATA_DICTIONARY_IN_OBJECT_SERVICE_IS_NULL;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_OBJECT_NAMES_ARRAY_FOR_OBJECT_SERVICE_IS_NULL;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_METADATA_TABLE_UPDATE_RECORD_FAILED;
FOUNDATION_EXPORT NSString *const EM_INTERAL_GENERIC_ERROR;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_UPLOAD_CACHE_DUPLICATE_ENTRY_FOR_SAME_OBJECT;
FOUNDATION_EXPORT NSString *const EM_INTERNAL_INVALID_OPTIONS;

@interface KSErrorMessages : NSObject

@end
