//
//  OrderedDictionary.h
//  OrderedDictionary
//
//  Created by Matt Gallagher on 19/12/08.
//  Copyright 2008 Matt Gallagher. All rights reserved.
//
//  Permission is given to use this source code file without charge in any
//  project, commercial or otherwise, entirely at your risk, with the condition
//  that any redistribution (in part or whole) of source code must retain
//  this copyright and permission notice. Attribution in compiled projects is
//  appreciated but not required.
//

#import <Foundation/Foundation.h>

@interface OrderedDictionary : NSMutableDictionary
{
	NSMutableDictionary *dictionary;
	NSMutableArray *array;
}

- (void)insertObject:(id)anObject forKey:(id)aKey atIndex:(NSUInteger)anIndex;

- (NSInteger)indexOf:(id)object;

- (id)keyAtIndex:(NSUInteger)anIndex;

- (id)valueAtIndex:(NSUInteger)anIndex;

- (NSEnumerator *)reverseKeyEnumerator;

- (NSEnumerator *)keyEnumerator;

- (void)removeAllObjects;

@end
